/* types.h
 *
 * Copyright 2019 Bruce Cowan <bruce@bcowan.me.uk>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#pragma once

#include <stdbool.h>

typedef void   (*FreeFunc)    (void       *data);
typedef void   (*ForEachFunc) (void       *data,
                               void       *user_data);
typedef double (*ValueFunc)   (const void *element);
typedef int    (*CompareFunc) (const void *a,
                               const void *b);
typedef bool   (*EqualFunc)   (const void *a,
                               const void *b);

typedef unsigned (*HashFunc)     (const void *key);
typedef void     (*HashIterFunc) (void       *key,
                                  void       *value,
                                  void       *user_data);
